﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Simple
{
    /* The Simple App Windows Form. This is based off the default C# WinForm class. */
    public partial class SimpleApp : Form
    {
        /* The public click event for SimpleCOM to subscribe to. */
        public delegate void ClickHandler(SimpleApp b, EventArgs e);
        public event ClickHandler comClick;

        /* Default constructor for a C# WinForm class. */
        public SimpleApp()
        {
            InitializeComponent();
        }

        /* Public property that keeps track of how many times the button has been clicked. */
        public int Count = 0;

        /* Public method to reset the button back to zero. */
        public void Reset()
        {
            this.Count = 0;
            button.Text = this.Count.ToString();
        }

        /* The click event handler for the actual button click */
        private void button_Click(object sender, EventArgs e)
        {
            this.Count++;
            button.Text = this.Count.ToString();

            /* This event is private and cannot be subscribed to so we trigger
             * the public click event here so that SimpleCOM can handle the
             * click event. We also have to avoid calling it if it has no
             * subscribers. */
            if (comClick != null)
                comClick(this, e);
        }
    }
}
